#!/usr/local/bin/ruby

      
keybind = []
for i in 0..127 do
  keybind[i] = []
end

keybind[ ?\C-b ] = [
  "backward_on_j_kakutei_mode",
  "NULL",
  "NULL",
  "NULL",
  "backward_on_latin_mode",
  "backward_on_latin_mode",
]

keybind[ ?\C-h ] = [
  "backspace_on_j_kakutei_mode",
  "backspace_on_j_henkan_on_mode",
  "backspace_on_j_henkan_okuri_mode",
  "backspace_on_j_henkan_active_mode",
  "backspace_on_latin_mode",
  "backspace_on_latin_mode",
  "backspace_on_abbrev_mode",
]

keybind[ ?\C-d ] = [
  "delete_on_j_kakutei_mode",
  "NULL",
  "NULL",
  "NULL",
  "delete_on_latin_mode",
  "delete_on_latin_mode",
]

keybind[ ?\C-f ] = [
  "forward_on_j_kakutei_mode",
  "NULL",
  "NULL",
  "NULL",
  "forward_on_latin_mode",
  "forward_on_latin_mode",
]

keybind[ ?\C-j ] = [
  "NULL",
  "kakutei_on_j_henkan_on_mode",
  "NULL",
  "kakutei_on_j_henkan_active_mode",
  "kakutei_on_latin_mode",
  "kakutei_on_latin_mode",
  "kakutei_on_abbrev_mode",
]

keybind[ ?\C-m ] = [
  "register_word_on_j_kakutei_mode",
  "kakutei_on_j_henkan_on_mode",
  "NULL",
  "kakutei_on_j_henkan_active_mode",
  "register_word_on_j_kakutei_mode",
  "register_word_on_j_kakutei_mode",
  "kakutei_on_abbrev_mode",
]

keybind[ ?\s  ] = [
  "space_on_j_kakutei_mode",
  "space_on_j_henkan_on_mode",
  "NULL",
  "space_on_j_henkan_active_mode",
  "space_on_latin_mode",
  "graph_on_jisx0208_latin_mode",
  "space_on_abbrev_mode",
]

keybind[ ?\C-g ] = [
  "cancel_on_j_kakutei_mode",
  "cancel_on_j_henkan_on_mode",
  "cancel_on_j_henkan_okuri_mode",
  "cancel_on_j_henkan_active_mode",
  "cancel_on_latin_mode",
  "cancel_on_latin_mode",
  "cancel_on_abbrev_mode",
]

keybind[ ?\C-t ] = [
  "mark_on_j_kakutei_mode",
  "NULL",
  "NULL",
  "NULL",
  "mark_on_latin_mode",
  "mark_on_latin_mode",
  "NULL"
]

keybind[ ?\C-w ] = [
  "cut_on_latin_mode",
  "NULL",
  "NULL",
  "NULL",
  "cut_on_latin_mode",
  "cut_on_latin_mode",
  "NULL"
]

keybind[ ?\C-y ] = [
  "yank_on_j_kakutei_mode",
  "NULL",
  "NULL",
  "NULL",
  "yank_on_latin_mode",
  "yank_on_latin_mode",
  "NULL",
]

GRAPH_KEYBIND = [
  "normal_on_j_kakutei_mode",
  "normal_on_j_henkan_on_mode",
  "graph_on_j_henkan_okuri_mode",
  "graph_on_j_henkan_active_mode",
  "graph_on_latin_mode",
  "graph_on_jisx0208_latin_mode",
  "graph_on_abbrev_mode",
]

UPPER_KEYBIND = [
  "upper_on_j_kakutei_mode",
  "upper_on_j_henkan_on_mode",
  "graph_on_j_henkan_okuri_mode",
  "graph_on_j_henkan_active_mode",
  "graph_on_latin_mode",
  "graph_on_jisx0208_latin_mode",
  "graph_on_abbrev_mode",
]

LOWER_KEYBIND = [
  "normal_on_j_kakutei_mode",
  "normal_on_j_henkan_on_mode",
  "graph_on_j_henkan_okuri_mode",
  "graph_on_j_henkan_active_mode",
  "graph_on_latin_mode",
  "graph_on_jisx0208_latin_mode",
  "graph_on_abbrev_mode",
]

for i in ?!..?~
  keybind[ i ] = GRAPH_KEYBIND
end
for i in ?A..?Z
  keybind[ i ] = UPPER_KEYBIND
end
for i in ?a..?z
  keybind[ i ] = LOWER_KEYBIND
end

keybind[ ?/ ] = [
  "change_to_abbrev_mode_on_j_kakutei_mode",
  "graph_on_j_henkan_on_mode",
  "NULL",
  "graph_on_j_henkan_active_mode",
  "graph_on_latin_mode",
  "graph_on_jisx0208_latin_mode",
  "graph_on_abbrev_mode",
]

keybind[ ?l ] = [
  "change_to_latin_mode_on_j_kakutei_mode",
  "change_to_latin_mode_on_j_henkan_on_mode",
  "NULL",
  "graph_on_j_henkan_active_mode",
  "graph_on_latin_mode",
  "graph_on_jisx0208_latin_mode",
  "graph_on_abbrev_mode",
]
keybind[ ?x ] = [
  "normal_on_j_kakutei_mode",
  "normal_on_j_henkan_on_mode",
  "graph_on_j_henkan_okuri_mode",
  "kouho_backward_on_j_henkan_active_mode",
  "graph_on_latin_mode",
  "graph_on_jisx0208_latin_mode",
  "graph_on_abbrev_mode",
]
keybind[ ?L ]  = [
  "change_to_jisx0208_latin_mode_on_j_kakutei_mode",
  "change_to_jisx0208_latin_mode_on_j_henkan_on_mode",
  "NULL",
  "graph_on_j_henkan_active_mode",
  "graph_on_latin_mode",
  "graph_on_jisx0208_latin_mode",
  "graph_on_abbrev_mode",
]

keybind[ ?q ] = [
  "toggle_katakana_on_j_kakutei_mode",
  "toggle_kata_on_j_henkan_on_mode",
  "graph_on_j_henkan_okuri_mode",
  "graph_on_j_henkan_active_mode",
  "graph_on_latin_mode",
  "graph_on_jisx0208_latin_mode",
  "graph_on_abbrev_mode",
]


print 'static SDLSKK_Keybind default_keybind[][7] = {', "\n"
keybind.each do |a|
  print '  { '
  for i in 0..6 do
    if a[i] then
      print a[i], ", "
    else
      print 'NULL, '
    end
  end
  print "},\n"
end
print "};\n"
