#include "sdlskk_internal.h"
#include <stdio.h>

int main( int argc, char** argv )
{
  char buf[1024];
  char out_buf[4098];
  
  SDLSKK_Dictionary* dict;  
  SDLSKK_RomKanaRuleTable* table;
  SDLSKK_Context* context;
  SDLSKK_Keybind* keybind;
  
  SDLSKK_set_encoding( SDLSKK_EUCJP );
  
  dict = SDLSKK_Dict_new();
  SDLSKK_Dict_load( dict, "test_jisyo", 0 );
  table = SDLSKK_RomKanaRuleTable_new( "test_rule_table" );
  keybind = SDLSKK_Keybind_new();
  SDLSKK_Keybind_set_default_key( keybind );
  
  context = SDLSKK_Context_new( dict, table, keybind, 0 );
  
  for(;;){
    fgets( buf, sizeof(buf), stdin );
    switch( buf[0] ){
    case 'a':
      SDLSKK_Context_input_key( context, buf[2] );
      break;
    case 'f':
      SDLSKK_Context_input_key( context, CTRL('f') );
      break;
    case 'b':
      SDLSKK_Context_input_key( context, CTRL('b') );
      break;
    case 'h':
      SDLSKK_Context_input_key( context, CTRL('h') );
      break;
    case 'q':
      return 0;
    }
    SDLSKK_Context_get_display_str( context, out_buf, sizeof(out_buf) );
    printf( "%s :%d\n", out_buf, context->cursor_pos );
  }
}
