#include "sdlskk_internal.h"
#include <stdio.h>
#include <stdlib.h>

void print_str( SDLSKK_Char* str )
{
  int i,j;
  unsigned char b;
  for( i=0; str[i] != 0; ++i ){
    for( j=3; j>=0; --j ){
      b = ( str[i] & ( ((unsigned int)0xFF) << j*8 ) ) >> j*8;
      if( b != 0 )
	putchar( b );
    }
  }
}

int main( int argc, char** argv )
{
  char buf[1024];
  SDLSKK_Char* prefix;  
  SDLSKK_RomKanaElement* element;  
  SDLSKK_RomKanaRuleTable* table;

  SDLSKK_set_encoding( SDLSKK_EUCJP );
  
  table = SDLSKK_RomKanaRuleTable_new( "test_rule_table" );

  for(;;){
    fgets( buf, sizeof(buf), stdin );
    if( buf[0]== ' ' )
      break;
    buf[ strlen(buf)-1 ] = '\0'; /* chop */
    prefix = SDLSKK_Str_new2( buf );
    printf( "%d ", SDLSKK_RomKanaRuleTable_get( table, prefix, &element ) );
    if( element != NULL ){
      print_str( element->next_state );
      print_str( element->hiragana );
      print_str( element->katakana );
    }
    putchar( '\n' );
    free( prefix );
  }
  return 0;
}
